//
// Created by 320051849 on 26/02/2022.
//

#ifndef TERMINAL_H
#define TERMINAL_H
#endif //TERMINAL_H


#include <Arduino.h>
#include "LCDWIKI_KBV.h"

#define BUFFER_LINES  10
#define BUFFER_CHARS  23

// Defined states for terminal update mechanism
typedef enum {
    No_Update = 0,
    Chars_Update = 1,
    Line_Update = 2
} Terminal_state_type;

class Terminal {

private:
    LCDWIKI_KBV *_lcd;    
    uint8_t  _lines;
    uint8_t  _chars;
    uint16_t _xLoc;
    uint16_t _yLoc;
    uint16_t _bg;
    uint16_t _fg;
    char     _buffer[BUFFER_LINES][BUFFER_CHARS] = { {'\0'} };
    int16_t  _index = 0;

public:
    // Variables
    Terminal_state_type State = No_Update;
    
    // Constructor
    Terminal(LCDWIKI_KBV *lcd, uint8_t lines, uint8_t chars, uint16_t xLoc, uint16_t yLoc, uint16_t bg, uint16_t fg);
    
    // Methods
    void WriteString(const char *str, uint16_t x, uint16_t y, uint8_t csize, uint16_t fc, uint16_t bc, boolean mode);
    void WriteTerminalLine(const char *str);
    void WriteTerminalChars(const char *str);
    void DisplayTerminal();
    void DisplayBuffer(uint16_t xLoc, uint16_t yLoc);
};



